/*=========================
===
Dynamix Data Base Connector
 II
===========================
===

Author:       Nikolay Mijaylov Mijaylov
e_mail:       nmmm@nsi.bg
CopyLeft:     
Distribution: GPL
A_DBC home    http://www.nmmm.nu/linux/a_dbc/
*/

#include "a_dbc.h"

#include <dlfcn.h>

const char *a_dbc_drivername         = "ADBC Dynamic Lib Loader Beta";
const char *a_dbc_drivercopyright    = "(c) 1998 - 2000, Nikolay Mijaylov";
const char *a_dbc_driverdistribution = "GPL";

void *h;

ADBConnection *getADBConnection(){
   h = dlopen ("./plugin.so", RTLD_LAZY);

   if(!h){
      printferr("Can't open dynamic lib!\n");
      exit(1);
   }

   ADBConnection *(*action)() = (ADBConnection *(*)()) dlsym(h, "getADBConnection");

   if (!action){
      printferr("Can't get symbol from dynamic lib!\n");
      exit(1);
   }

   ADBConnection *x = action();

   return x;
};

void closeADBConnection(){
   dlclose(h);
};
